package com.winhc.bigdata.spark.utils

import org.apache.hadoop.hbase.{HBaseConfiguration, HConstants}
import org.apache.hadoop.hbase.mapred.TableOutputFormat
import org.apache.hadoop.mapred.JobConf
import org.apache.spark.sql.SparkSession

import scala.collection.mutable

object SparkUtils {

  def HBaseOutputJobConf(outputTable: String): JobConf = {
    val config = HBaseConfiguration.create()
    var zkAddress: String = null
    if (System.getProperty("os.name").contains("Windows")) {
      zkAddress = "hb-proxy-pub-uf6as8i6h85k02092-001.hbase.rds.aliyuncs.com"
      import com.alibaba.dcm.DnsCacheManipulator
      DnsCacheManipulator.setDnsCache("hb-uf6as8i6h85k02092-001.hbase.rds.aliyuncs.com", "47.101.251.157")
    } else {
      zkAddress = "hb-uf6as8i6h85k02092-001.hbase.rds.aliyuncs.com"
    }
    config.set(HConstants.ZOOKEEPER_QUORUM, zkAddress);

    val jobConf = new JobConf(config)
    jobConf.setOutputFormat(classOf[TableOutputFormat])
    jobConf.set(TableOutputFormat.OUTPUT_TABLE, outputTable)
    jobConf
  }

  def InitEnv(appName: String): SparkSession = {
    InitEnv(appName, null)
  }

  def InitEnv(appName: String, config: mutable.Map[String, String]): SparkSession = {
    val spark = SparkSession
      .builder()
      .appName(appName)
      .config("spark.sql.broadcastTimeout", 20 * 60)
      .config("spark.sql.crossJoin.enabled", true)
      .config("spark.hadoop.odps.cupid.smartnat.enable", true)
      .config("odps.exec.dynamic.partition.mode", "nonstrict")
      .config("spark.hadoop.odps.project.name", "winhc_test_dev")
      .config("spark.hadoop.odps.access.id", "LTAI4G4n7pAW8tUbJVkkZQPD")
      .config("spark.hadoop.odps.access.key", "uNJOBskzcDqHq1TYG3m2rebR4c1009")
      .config("spark.sql.catalogImplementation", "odps")
      .config("spark.hadoop.odps.end.point", "http://service.cn.maxcompute.aliyun.com/api")
      .config("spark.hadoop.odps.runtime.end.point", "http://service.cn.maxcompute.aliyun-inc.com/api")
      .config("spark.hadoop.odps.cupid.vectorization.enable", false)

    if (System.getProperty("os.name").contains("Windows")) {
      spark.master("local[*]")
    }
    if (config != null) {
      for (e <- config) {
        spark.config(e._1, e._2)
      }
    }
    spark.getOrCreate()
  }
}
